const SpellingSummativeWord = require('../models/SpellingSummativeWord');
var spelling_summative_words = {};
//get spelling summative words
spelling_summative_words.getSpellingSummativeWord = (req, res) => {
    //validation
    var number_regex = /^[0-9]*$/;
    if (!req.query.category) return res.send({ status: 0, messsge: "Please provide category!" });
    if (!number_regex.test(req.query.category)) return res.send({ status: 0, message: "Please enter category as numeric value!" });
    if (!req.query.is_test_audio) return res.send({ status: 0, messsge: "Please provide test audio status!" });
    if (!number_regex.test(req.query.is_test_audio)) return res.send({ status: 0, message: "Please enter test audio status as numeric value!" });
    if (!parseInt(req.query.is_test_audio)) {
        var data = {
            category: req.query.category,
            is_deleted: 0,
            audio: { $ne: null }
        };
        var limit = 2;
    } else {
        var data = {
            is_deleted: 0,
            audio: { $ne: null }
        };
        var limit = 1;
    }

    SpellingSummativeWord.getSpellingSummativeWord(data, limit).then(result => {
        return res.send(result);
    }).catch(error => {
        return res.send(error);
    });
}
//save spelling summative test result
spelling_summative_words.saveSpellingSummativeTestResult = (req, res) => {
    //validation
    if (!req.body.student_teachers_id) return res.send({ status: 0, messsge: "Please provide student teachers id!" });
    if (!req.body.grade_level) return res.send({ status: 0, messsge: "Please provide student grade level!" });
    var grade_level_type = ['kindergarten', '1st grade', '2nd grade', '3rd grade'];
    if (!grade_level_type.includes(req.body.grade_level.toLowerCase())) return res.send({ status: 0, message: "Please provide valid grade level!" });
    if (!req.body.session) return res.send({ status: 0, messsge: "Please provide time of the year!" });
    if (!req.body.spelling_summative_word_id) return res.send({ status: 0, messsge: "Please provide speling summative word id!" });
    
    var data = {
        student_teachers_id: req.body.student_teachers_id,
        student_grade_level: req.body.grade_level,
        session: req.body.session,
        spelling_summative_word_id: req.body.spelling_summative_word_id,
        student_answer: req.body.student_answer ? req.body.student_answer : "",
        test_name: req.body.timestamp
    }
    SpellingSummativeWord.saveSpellingSummativeTestResult(data).then(result => {
        return res.send(result);
    }).catch(error => {
        return res.send(error);
    });
}
//complete current spelling test
spelling_summative_words.completeCurrentSpellingTest = (req, res) => {
    //validation
    if (!req.query.student_teachers_id) return res.send({ status: 0, messsge: "Please provide student teachers id!" });
    SpellingSummativeWord.completeCurrentSpellingTest(req.query.student_teachers_id).then(result => {
        return res.send(result);
    }).catch(error => {
        return res.send(error);
    });
}
module.exports = spelling_summative_words;
