
const emailValidator=require('email-validator');
const StudentTeacher=require('../models/StudentTeacher');
/* importing helpers */
const helpers = require('../helpers/helper');
var student_teachers={};
var async           = require("async");
//Teachers registration
student_teachers.teachersRegistration=(req,res)=>{
	//validation
	if(!req.body.student_teachers_email_address) return res.send({status:0,messsge:"Email address field cannot be blank!"});
	if(!emailValidator.validate(req.body.student_teachers_email_address)) return res.send({status:0,messsge:"Please enter valid email address!"});
	if(!req.body.student_teachers_password) return res.send({status:0,messsge:"Password field cannot be blank!"});
	if(!req.body.grade_level) return res.send({status:0,messsge:"Please provide grade level!"});
	var grade_level_arr=req.body.grade_level.split(",");
	var student_grade_level=[];
	grade_level_arr.map(grade_level=>{
		var grade_level_type=['kindergarten','1st grade','2nd grade','3rd grade','all'];
		if(!grade_level_type.includes(grade_level.toLowerCase())) return res.send({status:0,message:"Please provide valid grade level!"});
		if(grade_level=="all"){
			student_grade_level.push('1st grade','2nd grade','3rd grade')
		}else{
			student_grade_level.push(grade_level);
		}
	})
	var register_data={
		student_teachers_email_address:req.body.student_teachers_email_address,
		student_grade_level:student_grade_level,
		student_teachers_password: helpers.encrypt(req.body.student_teachers_password)
	} 
	//Teachers registration 
	StudentTeacher.teachersRegistration(register_data).then(result=>{
		return res.send(result);
    }).catch(error => {
        return res.send(error);
    });
	
}
//logout
student_teachers.logout=(req,res)=>{
	var signoutData={
		student_teachers_id:req.student_teachers_id
	}
	StudentTeacher.logout(signoutData).then(result => {
		return res.send({status:1,message:"You have successfully logged out..."});
	}).catch(error => {
		return res.send(error);
	});
}
//fetch all email id for grade level
student_teachers.fetchAllTeachersEmail=(req,res)=>{
	//validation
	if(!req.query.grade_level) return res.send({status:0,messsge:"Please provide grade level!"});
	var grade_level_arr=req.query.grade_level.split(",");
	var student_grade_level=[];
	grade_level_arr.map(grade_level=>{
		var grade_level_type=['kindergarten','1st grade','2nd grade','3rd grade','all'];
		if(!grade_level_type.includes(grade_level.toLowerCase())) return res.send({status:0,message:"Please provide valid grade level!"});
		if(grade_level=="all"){
			student_grade_level.push('1st grade','2nd grade','3rd grade')
		}else{
			student_grade_level.push(grade_level);
		}
	})
	var data={
		student_grade_level:student_grade_level
	} 
	//create account 
	StudentTeacher.fetchAllTeachersEmail(data).then(result=>{
		return res.send(result);
    }).catch(error => {
        return res.send(error);
    });
	
}
//Teacher's login
student_teachers.teachersLogin=(req,res)=>{
	//validation
	if(!req.body.student_teachers_email_address) return res.send({status:0,messsge:"Email address field cannot be blank!"});
	if(!emailValidator.validate(req.body.student_teachers_email_address)) return res.send({status:0,messsge:"Please enter valid email address!"});
	if(!req.body.student_teachers_password) return res.send({status:0,messsge:"Password field cannot be blank!"});
	if(!req.body.grade_level) return res.send({status:0,messsge:"Please provide grade level!"});
	var grade_level_arr=req.body.grade_level.split(",");
	var student_grade_level=[];
	grade_level_arr.map(grade_level=>{
		var grade_level_type=['kindergarten','1st grade','2nd grade','3rd grade','all'];
		if(!grade_level_type.includes(grade_level.toLowerCase())) return res.send({status:0,message:"Please provide valid grade level!"});
		if(grade_level=="all"){
			student_grade_level.push('1st grade','2nd grade','3rd grade')
		}else{
			student_grade_level.push(grade_level);
		}
	})
	var login_data={
		student_teachers_email_address:req.body.student_teachers_email_address,
		student_grade_level:student_grade_level,
		student_teachers_password:req.body.student_teachers_password
	} 
	//Teachers login
	StudentTeacher.teachersLogin(login_data).then(result=>{
		return res.send(result);
    }).catch(error => {
        return res.send(error);
    });
	
}
//Forgot Password 
student_teachers.forgotPassword=(req,res)=>{
	// validation 
	if(!req.body.student_teachers_email_address) return res.send({status:0,message:"Email id field cannot be blank!"});
	if(!emailValidator.validate(req.body.student_teachers_email_address)) return res.send({status:0,message:"Please enter valid email id!"});
	if(!req.body.grade_level) return res.send({status:0,messsge:"Please provide grade level!"});
	var grade_level_arr=req.body.grade_level.split(",");
	var student_grade_level=[];
	grade_level_arr.map(grade_level=>{
		var grade_level_type=['kindergarten','1st grade','2nd grade','3rd grade','all'];
		if(!grade_level_type.includes(grade_level.toLowerCase())) return res.send({status:0,message:"Please provide valid grade level!"});
		if(grade_level=="all"){
			student_grade_level.push('1st grade','2nd grade','3rd grade')
		}else{
			student_grade_level.push(grade_level);
		}
	})
	var data={ 
		student_teachers_email_address:req.body.student_teachers_email_address,
		student_grade_level:student_grade_level
	 };
	//forgot password
	StudentTeacher.forgotPassword(data).then(result=>{
		return res.send(result);
	}).catch(error=>{
		return res.send(error);
	})
}
//verify token for forgot password
student_teachers.verifyTokenForgotPassword=(req,res)=>{
	//validation
	if(!req.body.student_teachers_email_address) return res.send({status:0,message:"Please provide email id!"});
	if(!emailValidator.validate(req.body.student_teachers_email_address)) return res.send({status:0,message:"Please enter valid email id!"});
	if(!req.body.token) return res.send({status:0,message:"Please provide token number!"});
	//initialize 
	var data={
		email:req.body.student_teachers_email_address,
		unique_key:req.body.token
	} 
	//call user account model function verifyTokenForgotPassword
	StudentTeacher.verifyTokenForgotPassword(data).then(result=>{
		return res.send(result);
	}).catch(error=>{
		return res.send(error);
	}) 
}
//reset password
student_teachers.resetPassword=(req,res)=>{
	// validation 
	if(!req.body.student_teachers_email_address) return res.send({status:0,message:"Please provide email id!"});
	if(!emailValidator.validate(req.body.student_teachers_email_address)) return res.send({status:0,message:"Please enter valid email id!"});
	if(!req.body.new_password) return res.send({status:0,message:"New password field cannot be blank!"});
	//initialize reset password data
	var reset_password_data={
		student_teachers_password:req.body.new_password,
		student_teachers_email_address:req.body.student_teachers_email_address
	} 
	// reset Password
	StudentTeacher.resetPassword(reset_password_data).then(result=>{
		return res.send(result);
	}).catch(error=>{
		return res.send(error);
	})
}
//fetch student list
student_teachers.fetchStudent=(req,res)=>{
	// validation 
	if(!req.query.grade_level) return res.send({status:0,messsge:"Please provide grade level!"});
	var grade_level_arr=req.query.grade_level.split(",");
	var student_grade_level=[];
	grade_level_arr.map(grade_level=>{
		var grade_level_type=['kindergarten','1st grade','2nd grade','3rd grade','all'];
		if(!grade_level_type.includes(grade_level.toLowerCase())) return res.send({status:0,message:"Please provide valid grade level!"});
		if(grade_level=="all"){
			student_grade_level.push('1st grade','2nd grade','3rd grade')
		}else{
			student_grade_level.push(grade_level);
		}
	})
	//initialize data
	var data={
		student_teachers_email_address:req.student_teachers_email_address,
		student_grade_level:student_grade_level
	} 
	//fetch student list
	StudentTeacher.fetchStudent(data).then(result=>{
		return res.send(result);
	}).catch(error=>{
		return res.send(error);
	})
}
//sentence list
student_teachers.sentenceList=(req,res)=>{
	// validation 
	if(!req.query.grade_level) return res.send({status:0,messsge:"Please provide grade level!"});
	var grade_level_type=['kindergarten','1st grade','2nd grade','3rd grade'];
    if(!grade_level_type.includes(req.query.grade_level.toLowerCase())) return res.send({status:0,message:"Please provide valid grade level!"});
	//initialize data
	var data={
		student_grade_level:req.query.grade_level,
		is_deleted:0
	} 
	//sentence list
	StudentTeacher.sentenceList(data).then(result=>{
		return res.send(result);
	}).catch(error=>{
		return res.send(error);
	})
}



student_teachers.forgotPasswordNew = function (req, res, next) {
    if(!req.body.email) {
        return res.send({"status" : 0,"msg" : 'Email Parameters missing.'});
    }

    var where               				= {};
    var data                				= {};
    where.student_teachers_email_address    = req.body.email;
    where.is_deleted                        = '0';
    where.is_active                         = "1";

    async.waterfall([
        function(callback)
        {
            StudentTeacher.getUserProfile(res,where,function(userlist){
                if(userlist!=null) {
                	var userlist = JSON.parse(JSON.stringify(userlist));
                    callback(null,userlist);
                    //console.log(userlist);
                } else {
                    return res.send({"status" : 0,"msg" : 'Invalid email.'});
                }
            });
        },
        function(userlist,callback)
        {   

        	//console.log(userlist);
        	StudentTeacher.sentOtpMail(res,userlist,function(sentMail){
        		var sentMail = JSON.parse(JSON.stringify(sentMail));
         		callback(null,sentMail)
            });
        }
    ],function(error,sentMail)
    {
        return res.send({
            status: 1,
            msg: sentMail.message,
        });
    });
}


student_teachers.resetPasswordNew = function (req, res, next) {
	
    if(!req.body.password || !req.body.confirm_password || !req.body.otp) {
        return res.send({"status" : 0,"msg" : 'Parameters missing.'});
    }

    var password         = req.body.password;
    var confirm_password = req.body.confirm_password;
    var otp 			 = req.body.otp;

    if (password!=confirm_password) { return res.send({"status" : 0,"msg" : 'Password and confirm password does not match'}); }

   
    async.waterfall([
    	function(callback)
        {
            StudentTeacher.checkOldPassword(res,otp,password,function(checkPassword){
            	console.log(checkPassword.count);

                if(checkPassword.count==0) {
                    callback(null,checkPassword);
                } else {
                    return res.send({"status" : 0, "msg" : "You can't reuse your old password"});
                }
            });
        },
        function(checkPassword,callback)
        {
            StudentTeacher.updateNewPassword(res,otp,password,function(updatePassword){
            	console.log(updatePassword[0]);

                if(updatePassword[0]>0) {
                	var updatePassword = JSON.parse(JSON.stringify(updatePassword));
                    callback(null,updatePassword);
                } else {
                    return res.send({"status" : 0, "msg" : 'OTP does not match'});
                }
            });
        } 
    ],function(error,updatePassword)
    {
        return res.send({
            status: 1,
            msg: "Password has been reset successfully!",
        });
    });
}








module.exports=student_teachers;