/* importing crypo module for generating unique token */
const crypto=require('crypto');
/* importing sendgrid mail configuration */
const SGmail=require('../config/sendGrid');
/* importing fs for file read or write */
var fs = require('fs');
var helpers={};
//generate unique token
helpers.generateUniqueToken = ()=>{
    var current_date = (new Date()).valueOf().toString();
    var random = Math.random().toString();
    var token = crypto.createHash('sha1').update(current_date + random).digest('hex');
    return token;
}
//read html file
helpers.readHTMLFile=(path, callback)=>{
  fs.readFile(path, {encoding: 'utf-8'}, function (err, html) {
       if (err) callback(err);
       else callback(null, html);
   });
}
//sent mail using sendgrid
helpers.sentMail=(email,subject,from,html,callback)=>{
  SGmail.send({
      from: from,
      to:email,
      subject: subject,
      html : html
  }).then(response=>{
      callback({status:1,success:response,messasge:"Mail sent successfully"});
  }).catch(error=>{
      callback({status:0,error:error,messasge:"Error in sending mail"});
  });
}
//encrypt
helpers.encrypt = (password)=>{
    const cipher = crypto.createCipher('aes192', 'a password');
    let encrypted = cipher.update(password, 'utf8', 'hex');
    encrypted += cipher.final('hex');
    return encrypted;
  }
//decrypt
helpers.decrypt = (encrypted)=>{
  const decipher = crypto.createDecipher('aes192', 'a password');
  let decrypted = decipher.update(encrypted, 'hex', 'utf8');
  decrypted += decipher.final('utf8');
  return decrypted;
}


helpers.encryption = (password)=>{
  const algorithm       = 'aes-256-ctr';
  const ENCRYPTION_KEY  = Buffer.from('FoCKvdLslUuB4y3EZlKate7XGottHski1LmyqJHvUhs=', 'base64')
  const IV_LENGTH       = 16;

  let iv        = crypto.randomBytes(IV_LENGTH);
  let cipher    = crypto.createCipheriv(algorithm, Buffer.from(ENCRYPTION_KEY, 'hex'), iv);
  let encrypted = cipher.update(password);
  encrypted     = Buffer.concat([encrypted, cipher.final()]);
  return iv.toString('hex') + ':' + encrypted.toString('hex');
}
//decrypt
helpers.decryption = (encrypted)=>{
  const algorithm       = 'aes-256-ctr';
  const ENCRYPTION_KEY  = Buffer.from('FoCKvdLslUuB4y3EZlKate7XGottHski1LmyqJHvUhs=', 'base64')
  const IV_LENGTH       = 16;

  let textParts     = encrypted.split(':');
  let iv            = Buffer.from(textParts.shift(), 'hex');
  let encryptedText = Buffer.from(textParts.join(':'), 'hex');
  let decipher      = crypto.createDecipheriv(algorithm, Buffer.from(ENCRYPTION_KEY, 'hex'), iv);
  let decrypted     = decipher.update(encryptedText);
  decrypted         = Buffer.concat([decrypted, decipher.final()]);
  return decrypted.toString();
}


module.exports=helpers;