const multer = require('multer');
const path = require('path');
var fileUpload = multer({
    storage: multer.diskStorage({
        destination: function(req,file, cb) {
          cb(null, req.upload_path);
        },
        filename: function (req, file, cb) {
            var fntype = path.extname(file.originalname).toLowerCase();
            cb(null,Date.now()+fntype) 
        }
    }),
   // limits:{ fileSize: 5*1024*1024 },//5 mb
    fileFilter: function (req, file, cb) {     
        var filetypes = /wav|aif|mp3|mid/;
        var extname = filetypes.test(path.extname(file.originalname).toLowerCase());        
        if (extname) return cb(null, true); 
        else {
            var fileTypeError = "File upload only supports the following filetypes - " + filetypes;
            req.fileTypeError=fileTypeError;
            cb(null,false);
        }
    }
}).single('file');

module.exports={
    fileUpload:fileUpload
}
