/* Importing schemas */
const StudentTeacher = require('./schemas/StudentTeacherSchema');
const SentenceFluencyTestResult = require('./schemas/SentenceFluencyTestResult');
/* Importing database*/
const Sequelize = require('sequelize');
const sequelize = require('../config/database').sequelize;
/* importing */
const async=require('async');

var sentence_fluency_test_results={};

//Save Sentence Fluency Test Result
sentence_fluency_test_results.saveSentenceFluencyTestResult=(data)=>{
	return new Promise((resolve,reject)=>{
		async.waterfall([
            checkStudentExistence,
			saveSentenceFluencyTestResult,
		],(err, result)=> {
			if(err.status==0) reject(result);
			else resolve(result);
		});
		//check student exist or not using student teachers id and grade level
		function checkStudentExistence(callback){
			StudentTeacher.findOne({
				where:{ 
					student_teachers_id:data.student_teachers_id,	
					student_grade_level:data.student_grade_level 
				},
			}).then(student_teachers_details=>{
				if(student_teachers_details) callback(null,student_teachers_details);
				else callback({status:1},{status:0,message:"Invalid Student!"});
			}).catch(err=>{
				callback({status:0},{status:0,error:err,message:"Error in server. Please try after some time"});
			})
        }
        //Save Sentence Fluency Test Result
		function saveSentenceFluencyTestResult(student_teachers_details,callback){
			data.student_id=student_teachers_details.student_id;
			data.student_teachers_email_address=student_teachers_details.student_teachers_email_address;
			data.student_name=student_teachers_details.student_first_name+" "+student_teachers_details.student_middle_name+" "+student_teachers_details.student_last_name;
			data.student_teachers_name=student_teachers_details.student_teachers_first_name+" "+student_teachers_details.student_teachers_last_name;
			SentenceFluencyTestResult.create(data).then(response=>{
				callback({status:1},{status:1,message:"Sentence Fluency test result has been saved successfully"});
			}).catch(err=>{
				callback({status:0},{status:0,error:err,message:"Error in server. Please try after some time"});
			})
		}
	});
}
module.exports = sentence_fluency_test_results;
